diff --git a/drivers/spi/spi-fsl-dspi.c b/drivers/spi/spi-fsl-dspi.c
index 41422cd..db7f091 100644
--- a/drivers/spi/spi-fsl-dspi.c
+++ b/drivers/spi/spi-fsl-dspi.c
@@ -217,15 +217,13 @@ static void dspi_rx_dma_callback(void *arg)
        struct fsl_dspi *dspi = arg;
        struct fsl_dspi_dma *dma = dspi->dma;
        int rx_word;
-       int i, len;
+       int i;
        u16 d;
 
        rx_word = is_double_byte_mode(dspi);
 
-       len = rx_word ? (dma->curr_xfer_len / 2) : dma->curr_xfer_len;
-
        if (!(dspi->dataflags & TRAN_STATE_RX_VOID)) {
-               for (i = 0; i < len; i++) {
+               for (i = 0; i < dma->curr_xfer_len; i++) {
                        d = dspi->dma->rx_dma_buf[i];
                        rx_word ? (*(u16 *)dspi->rx = d) :
                                                (*(u8 *)dspi->rx = d);
@@ -242,14 +240,12 @@ static int dspi_next_xfer_dma_submit(struct fsl_dspi *dspi)
        struct device *dev = &dspi->pdev->dev;
        int time_left;
        int tx_word;
-       int i, len;
+       int i;
        u16 val;
 
        tx_word = is_double_byte_mode(dspi);
 
-       len = tx_word ? (dma->curr_xfer_len / 2) : dma->curr_xfer_len;
-
-       for (i = 0; i < len - 1; i++) {
+       for (i = 0; i < dma->curr_xfer_len - 1; i++) {
                val = tx_word ? *(u16 *) dspi->tx : *(u8 *) dspi->tx;
                dspi->dma->tx_dma_buf[i] =
                        SPI_PUSHR_TXDATA(val) | SPI_PUSHR_PCS(dspi->cs) |
@@ -267,7 +263,9 @@ static int dspi_next_xfer_dma_submit(struct fsl_dspi *dspi)
 
        dma->tx_desc = dmaengine_prep_slave_single(dma->chan_tx,
                                        dma->tx_dma_phys,
-                                       DSPI_DMA_BUFSIZE, DMA_MEM_TO_DEV,
+                                       dma->curr_xfer_len *
+                                       DMA_SLAVE_BUSWIDTH_4_BYTES,
+                                       DMA_MEM_TO_DEV,
                                        DMA_PREP_INTERRUPT | DMA_CTRL_ACK);
        if (!dma->tx_desc) {
                dev_err(dev, "Not able to get desc for DMA xfer\n");
@@ -283,7 +281,9 @@ static int dspi_next_xfer_dma_submit(struct fsl_dspi *dspi)
 
        dma->rx_desc = dmaengine_prep_slave_single(dma->chan_rx,
                                        dma->rx_dma_phys,
-                                       DSPI_DMA_BUFSIZE, DMA_DEV_TO_MEM,
+                                       dma->curr_xfer_len *
+                                       DMA_SLAVE_BUSWIDTH_4_BYTES,
+                                       DMA_DEV_TO_MEM,
                                        DMA_PREP_INTERRUPT | DMA_CTRL_ACK);
        if (!dma->rx_desc) {
                dev_err(dev, "Not able to get desc for DMA xfer\n");
@@ -330,17 +330,17 @@ static int dspi_dma_xfer(struct fsl_dspi *dspi)
        struct device *dev = &dspi->pdev->dev;
        int curr_remaining_bytes;
        int bytes_per_buffer;
-       int tx_word;
+       int tx_word = 1;
        int ret = 0;
 
-       tx_word = is_double_byte_mode(dspi);
+       if (is_double_byte_mode(dspi))
+               tx_word = 2;
        curr_remaining_bytes = dspi->len;
+       bytes_per_buffer = DSPI_DMA_BUFSIZE / DSPI_FIFO_SIZE;
        while (curr_remaining_bytes) {
                /* Check if current transfer fits the DMA buffer */
-               dma->curr_xfer_len = curr_remaining_bytes;
-               bytes_per_buffer = DSPI_DMA_BUFSIZE /
-                               (DSPI_FIFO_SIZE / (tx_word ? 2 : 1));
-               if (curr_remaining_bytes > bytes_per_buffer)
+               dma->curr_xfer_len = curr_remaining_bytes / tx_word;
+               if (dma->curr_xfer_len > bytes_per_buffer)
                        dma->curr_xfer_len = bytes_per_buffer;
 
                ret = dspi_next_xfer_dma_submit(dspi);
@@ -349,7 +349,7 @@ static int dspi_dma_xfer(struct fsl_dspi *dspi)
                        goto exit;
 
                } else {
-                       curr_remaining_bytes -= dma->curr_xfer_len;
+                       curr_remaining_bytes -= dma->curr_xfer_len * tx_word;
                        if (curr_remaining_bytes < 0)
                                curr_remaining_bytes = 0;
                        dspi->len = curr_remaining_bytes;